<a id="mypy-boto3-customer-profiles"></a>

# mypy-boto3-customer-profiles

[![PyPI - mypy-boto3-customer-profiles](https://img.shields.io/pypi/v/mypy-boto3-customer-profiles.svg?color=blue)](https://pypi.org/project/mypy-boto3-customer-profiles)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-customer-profiles.svg?color=blue)](https://pypi.org/project/mypy-boto3-customer-profiles)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/mypy-boto3-customer-profiles?color=blue)](https://pypistats.org/packages/mypy-boto3-customer-profiles)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.CustomerProfiles 1.20.13](https://boto3.amazonaws.com/v1/documentation/api/1.20.13/reference/services/customer-profiles.html#CustomerProfiles)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.2.1](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-customer-profiles docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_customer_profiles/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-customer-profiles](#mypy-boto3-customer-profiles)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `CustomerProfiles`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `CustomerProfiles` service.

```bash
python -m pip install boto3-stubs[customer-profiles]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[customer-profiles]` in your environment:
  `python -m pip install 'boto3-stubs[customer-profiles]'`

Both type checking and auto-complete should work for `CustomerProfiles`
service. No explicit type annotations required, write your `boto3` code as
usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[customer-profiles]` in your environment:
  `python -m pip install 'boto3-stubs[customer-profiles]'`

Both type checking and auto-complete should work for `CustomerProfiles`
service. No explicit type annotations required, write your `boto3` code as
usual. Auto-complete can be slow on big projects or if you have a lot of
installed `boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[customer-profiles]` in your environment:
  `python -m pip install 'boto3-stubs[customer-profiles]'`
- Run `mypy` as usual

Type checking should work for `CustomerProfiles` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[customer-profiles]` in your environment:
  `python -m pip install 'boto3-stubs[customer-profiles]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `CustomerProfiles` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`CustomerProfilesClient` provides annotations for
`boto3.client("customer-profiles")`.

```python
import boto3

from mypy_boto3_customer_profiles import CustomerProfilesClient

client: CustomerProfilesClient = boto3.client("customer-profiles")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: CustomerProfilesClient = session.client("customer-profiles")
```

<a id="literals"></a>

### Literals

`mypy_boto3_customer_profiles.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_customer_profiles.literals import (
    ConflictResolvingModelType,
    DataPullModeType,
    FieldContentTypeType,
    GenderType,
    IdentityResolutionJobStatusType,
    JobScheduleDayOfTheWeekType,
    MarketoConnectorOperatorType,
    OperatorPropertiesKeysType,
    PartyTypeType,
    S3ConnectorOperatorType,
    SalesforceConnectorOperatorType,
    ServiceNowConnectorOperatorType,
    SourceConnectorTypeType,
    StandardIdentifierType,
    TaskTypeType,
    TriggerTypeType,
    ZendeskConnectorOperatorType,
    ServiceName,
)

def check_value(value: ConflictResolvingModelType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_customer_profiles.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_customer_profiles.type_defs import (
    AddProfileKeyRequestRequestTypeDef,
    AddProfileKeyResponseTypeDef,
    AddressTypeDef,
    AutoMergingTypeDef,
    ConflictResolutionTypeDef,
    ConnectorOperatorTypeDef,
    ConsolidationTypeDef,
    CreateDomainRequestRequestTypeDef,
    CreateDomainResponseTypeDef,
    CreateProfileRequestRequestTypeDef,
    CreateProfileResponseTypeDef,
    DeleteDomainRequestRequestTypeDef,
    DeleteDomainResponseTypeDef,
    DeleteIntegrationRequestRequestTypeDef,
    DeleteIntegrationResponseTypeDef,
    DeleteProfileKeyRequestRequestTypeDef,
    DeleteProfileKeyResponseTypeDef,
    DeleteProfileObjectRequestRequestTypeDef,
    DeleteProfileObjectResponseTypeDef,
    DeleteProfileObjectTypeRequestRequestTypeDef,
    DeleteProfileObjectTypeResponseTypeDef,
    DeleteProfileRequestRequestTypeDef,
    DeleteProfileResponseTypeDef,
    DomainStatsTypeDef,
    ExportingConfigTypeDef,
    ExportingLocationTypeDef,
    FieldSourceProfileIdsTypeDef,
    FlowDefinitionTypeDef,
    GetAutoMergingPreviewRequestRequestTypeDef,
    GetAutoMergingPreviewResponseTypeDef,
    GetDomainRequestRequestTypeDef,
    GetDomainResponseTypeDef,
    GetIdentityResolutionJobRequestRequestTypeDef,
    GetIdentityResolutionJobResponseTypeDef,
    GetIntegrationRequestRequestTypeDef,
    GetIntegrationResponseTypeDef,
    GetMatchesRequestRequestTypeDef,
    GetMatchesResponseTypeDef,
    GetProfileObjectTypeRequestRequestTypeDef,
    GetProfileObjectTypeResponseTypeDef,
    GetProfileObjectTypeTemplateRequestRequestTypeDef,
    GetProfileObjectTypeTemplateResponseTypeDef,
    IdentityResolutionJobTypeDef,
    IncrementalPullConfigTypeDef,
    JobScheduleTypeDef,
    JobStatsTypeDef,
    ListAccountIntegrationsRequestRequestTypeDef,
    ListAccountIntegrationsResponseTypeDef,
    ListDomainItemTypeDef,
    ListDomainsRequestRequestTypeDef,
    ListDomainsResponseTypeDef,
    ListIdentityResolutionJobsRequestRequestTypeDef,
    ListIdentityResolutionJobsResponseTypeDef,
    ListIntegrationItemTypeDef,
    ListIntegrationsRequestRequestTypeDef,
    ListIntegrationsResponseTypeDef,
    ListProfileObjectTypeItemTypeDef,
    ListProfileObjectTypeTemplateItemTypeDef,
    ListProfileObjectTypeTemplatesRequestRequestTypeDef,
    ListProfileObjectTypeTemplatesResponseTypeDef,
    ListProfileObjectTypesRequestRequestTypeDef,
    ListProfileObjectTypesResponseTypeDef,
    ListProfileObjectsItemTypeDef,
    ListProfileObjectsRequestRequestTypeDef,
    ListProfileObjectsResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    MarketoSourcePropertiesTypeDef,
    MatchItemTypeDef,
    MatchingRequestTypeDef,
    MatchingResponseTypeDef,
    MergeProfilesRequestRequestTypeDef,
    MergeProfilesResponseTypeDef,
    ObjectFilterTypeDef,
    ObjectTypeFieldTypeDef,
    ObjectTypeKeyTypeDef,
    ProfileTypeDef,
    PutIntegrationRequestRequestTypeDef,
    PutIntegrationResponseTypeDef,
    PutProfileObjectRequestRequestTypeDef,
    PutProfileObjectResponseTypeDef,
    PutProfileObjectTypeRequestRequestTypeDef,
    PutProfileObjectTypeResponseTypeDef,
    ResponseMetadataTypeDef,
    S3ExportingConfigTypeDef,
    S3ExportingLocationTypeDef,
    S3SourcePropertiesTypeDef,
    SalesforceSourcePropertiesTypeDef,
    ScheduledTriggerPropertiesTypeDef,
    SearchProfilesRequestRequestTypeDef,
    SearchProfilesResponseTypeDef,
    ServiceNowSourcePropertiesTypeDef,
    SourceConnectorPropertiesTypeDef,
    SourceFlowConfigTypeDef,
    TagResourceRequestRequestTypeDef,
    TaskTypeDef,
    TriggerConfigTypeDef,
    TriggerPropertiesTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateAddressTypeDef,
    UpdateDomainRequestRequestTypeDef,
    UpdateDomainResponseTypeDef,
    UpdateProfileRequestRequestTypeDef,
    UpdateProfileResponseTypeDef,
    ZendeskSourcePropertiesTypeDef,
)

def get_structure() -> AddProfileKeyRequestRequestTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-customer-profiles` version is the same as related `boto3` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-customer-profiles docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_customer_profiles/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
